<?php

	// if your 'plugin' directory is not in the default location,
	// edit this variable to point to your site directory
	// (where config.php is)
	$strRel = '../../../';

	require_once(dirname(__FILE__).'/Info.php');
	require_once(dirname(__FILE__).'/driver.php');
	require_once(dirname(__FILE__).'/oauth/twitteroauth.php');
	
	$action=$_REQUEST['twitter_action'];
	if(strcmp($action,'authorize_redirect')==0){
		/* Start session and load library. */
		session_start();
		
		/* Build TwitterOAuth object with client credentials. */
		$consumerKey=$TWITTER['CONSUMER_KEY'];
		$consumerSecret=$TWITTER['CONSUMER_SECRET'];
		$connection = new TwitterOAuth($consumerKey, $consumerSecret);

		/* Get temporary credentials. */
		include($strRel . 'config.php');
		if (!$member->isLoggedIn())
			doError('You\'re not logged in.');
		include($DIR_LIBS . 'PLUGINADMIN.php');
		$oPluginAdmin = new PluginAdmin($TWITTER['COMPACT_TITLE']);
		$callbackURL=$oPluginAdmin->plugin->getAdminURL().'?twitter_action=authorize_callback&ticket='.$_REQUEST['ticket'];
		$request_token = $connection->getRequestToken($callbackURL);
		
		/* Save temporary credentials to session. */
		$_SESSION['oauth_token'] = $token = $request_token['oauth_token'];
		$_SESSION['oauth_token_secret'] = $request_token['oauth_token_secret'];
		 
		/* If last connection failed don't display authorization link.*/ 
		switch ($connection->http_code) {
		  case 200:
		    /* Build authorize URL and redirect user to Twitter. */
		    $url = $connection->getAuthorizeURL($token);
		    //$oPluginAdmin->start('<meta http-equiv="REFRESH" content="0;url='.$url.'">');
		    header('Location: ' . $url.'&ticket='.$_REQUEST['ticket']); 
		    break;
		  default:
		    /* Show notification if something went wrong.*/ 
		    $oPluginAdmin->start();
		  	echo 'Could not connect to Twitter. Refresh the page or try again later. Response: '.$connection->http_code.' ('.$consumerKey.', '.$consumerSecret.', '.$callbackURL.')';
		}
	}
	elseif(strcmp($action,'authorize_callback')==0){
		/* Start session and load library. */
		session_start();

		/* If the oauth_token is old redirect to the connect page. */
		if (isset($_REQUEST['oauth_token']) && $_SESSION['oauth_token'] !== $_REQUEST['oauth_token']) {
		  $_SESSION['oauth_status'] = 'oldtoken';
		  header('Location: ./clearsessions.php');
		}
		
		/* Create TwitteroAuth object with app key/secret and token key/secret from default phase */
		$connection = new TwitterOAuth($TWITTER['CONSUMER_KEY'], $TWITTER['CONSUMER_SECRET'], $_SESSION['oauth_token'], $_SESSION['oauth_token_secret']);
		
		/* Request access tokens from twitter */
		$access_token = $connection->getAccessToken($_REQUEST['oauth_verifier']);
		
		include($strRel . 'config.php');
		if (!$member->isLoggedIn())
			doError('You\'re not logged in.');
		/* Save the access tokens. Normally these would be saved in a database for future use. */
		$success=false;
		$userID=$member->id;
		$success=TwitterDriver::setAccessTokenForUser($userID,$access_token);
		
		/* Remove no longer needed request tokens */
		unset($_SESSION['oauth_token']);
		unset($_SESSION['oauth_token_secret']);
		
		include($DIR_LIBS . 'PLUGINADMIN.php');
		$oPluginAdmin = new PluginAdmin($TWITTER['COMPACT_TITLE']);
		$callbackURL=$oPluginAdmin->plugin->getAdminURL().'?ticket='.$_REQUEST['ticket'];
		/* If HTTP response is 200 continue otherwise send to connect page to retry */
		if (200 == $connection->http_code) {
		  	/* The user has been verified and the access tokens can be saved for future use */
		  	$_SESSION['status'] = 'verified';
		  	header('Location: '.$callbackURL);
		} else {
		  	/* Save HTTP status for error dialog on connnect page.*/
			header('Location: '.$callbackURL);
		}
	}
	else{
		session_start();
		include($strRel . 'config.php');
		if (!$member->isLoggedIn())
			doError('You\'re not logged in.');
	
		include($DIR_LIBS . 'PLUGINADMIN.php');
	
		// create the admin area page
		$oPluginAdmin = new PluginAdmin($TWITTER['COMPACT_TITLE']);
		$oPluginAdmin->start();
		
		if(isset($_SESSION['oauth_token']))
			unset($_SESSION['oauth_token']);
		if(isset($_SESSION['oauth_token_secret']))
			unset($_SESSION['oauth_token_secret']);
		
		$userID=$member->id;
		$accessToken=TwitterDriver::getAccessTokenForUser($userID);
		
		if(TwitterDriver::isValidAccessToken($accessToken))
			echo '<p>Your account appears to have been twitter-enabled. If there appears to be an issue still, you can reinitiate the process by clicking on the link below.</p>'."\n";
		else
			echo '<p>Your account has not been twitter-enabled. Click on the link below to authorize '.$TWITTER['TITLE'].' to send tweets for you.</p>'."\n";
		echo '<p><a href="'.$oPluginAdmin->plugin->getAdminURL().'?twitter_action=authorize_redirect">Authorize '.$TWITTER['TITLE'].' to send tweets for you.</a></p>'."\n";
		
		$oPluginAdmin->end();
	}
	
?>